#ifndef STARSFunction_h
#define STARSFunction_h


class SMPFunction;

class STARS_Function_t
{
	public:
                virtual char* GetFunctionName(const char* name, const int len) const =0;
                virtual STARS_ea_t get_startEA()=0;
                virtual STARS_ea_t get_endEA()=0;
		virtual size_t GetFrameSize()=0;
		virtual void SetFrameSize(size_t size)=0;
                virtual size_t GetSavedRegSize()=0;
		virtual size_t GetIncomingArgumentSize()=0;
		virtual size_t GetFrameReturnAddressSize()=0;
                virtual bool FunctionUsesFP()=0;
                virtual bool IsStaticFunction()=0;
                virtual bool IsLibraryFunction()=0;
                virtual bool IsStackPointerAnalyzed()=0;
		virtual uint64_t get_spd(STARS_ea_t ea)=0;
		virtual bool HasReturnPoints()=0;
		virtual bool IsMultiEntry()=0;
		virtual void MarkSharedChunks()=0;
		virtual bool HasSharedChunks() const =0;
		virtual void SetSharedChunks(bool v) =0;
                virtual void UpdateXrefs()=0;
		virtual void BuildFuncIR(SMPFunction *func)=0;



};

#endif
